/*
 *  Copyright (C) 2014-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *  
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: DriveManager.c 122 2015-07-17 01:31:28Z ertl-honda $
 */  

/*
 *		CDD SW-C DriveManagerѤε
 */

#include "Rte_DriveManager.h"
#include "ModelCarControl.h"
#include "t_syslog.h"

/*
 *  ƥ󥰤Υ˥塼ȥ
 */
static IDT_Angle	steer_neutral = STEER_NEUTRAL_INIT;

/*
 *  ®Υ
 */
static uint8		speed_gain = SPEED_GAIN_INIT;

/*
 *  ƥ󥰥˥塼ȥ®ĴACKλ
 */
#define ACK_CNT_MAX		8U

/*
 *  ƥ󥰥˥塼ȥ®ĴACKѿ
 */
static uint8	acklr_cnt = 0U;
static uint8	ackr_cnt = 0U;
static uint8	ackl_cnt = 0U;

/*
 * 
 * ʥ֥֤Ƕͭ뤿˶ͭѿȤ 
 */
static IDT_Angle	cur_angle;
static IDT_Speed	cur_speed;
static IDT_Adjust	cur_steern;
static IDT_Adjust	cur_gain;
static IDT_Brake	cur_brake;

/*
 *  DrivingControlʥ֥
 */
void
DrivingControl(void)
{
	Std_ReturnType	ercd;

	/* IfDriving */
	ercd = Rte_Read_DrivingIn_angle(&cur_angle);
	ercd += Rte_Read_DrivingIn_speed(&cur_speed);
	ercd += Rte_Read_DrivingIn_steern(&cur_steern);
	ercd += Rte_Read_DrivingIn_gain(&cur_gain);
	ercd += Rte_Read_DrivingIn_brake(&cur_brake);

	/* 1ĤǤ˼Ԥ³νϼ¹Ԥʤ */
	if (ercd != RTE_E_OK) {
		syslog(LOG_INFO, "## Error: Rte_Read_DrivingIn()");
		return;
	}

	/* ƥ󥰥˥塼ȥĴ */
	switch (cur_steern) {
	  case CONTCMD_STEERN_I:
		steer_neutral = STEER_NEUTRAL_INIT;
		acklr_cnt = ACK_CNT_MAX;
		break;
	  case CONTCMD_STEERN_R:
		/* (-)Ĵ */
		if (steer_neutral > STEER_NEUTRAL_MIN) {
			steer_neutral--;
		}
		ackr_cnt = ACK_CNT_MAX;
		break;
	  case CONTCMD_STEERN_L:
		/* (+)Ĵ */
		if (steer_neutral < STEER_NEUTRAL_MAX) {
			steer_neutral++;
		}
		ackl_cnt = ACK_CNT_MAX;
		break;
	  default:
		/* ׵ʤ */
		break;
	}

	/* Ĵ */
	switch (cur_gain) {
	  case CONTCMD_GAIN_I:
		speed_gain = SPEED_GAIN_INIT;
		acklr_cnt = ACK_CNT_MAX;
		break;
	  case CONTCMD_GAIN_U:
		/* 夲 */
		if (speed_gain < SPEED_GAIN_MAX) {
			speed_gain++;
		}
		ackr_cnt = ACK_CNT_MAX;
		break;
	  case CONTCMD_GAIN_D:
		/* 򲼤 */
		if (speed_gain > SPEED_GAIN_MIN) {
			speed_gain--;
		}
		ackl_cnt = ACK_CNT_MAX;
		break;
	  default:
		/* ׵ʤ */
		break;
	}

	/* ɳ(-6364) */
	Rte_Call_AngleClt_OpSetSteerAngle(cur_angle + steer_neutral);

	/* ®(-6364) */
	Rte_Call_SpeedClt_OpSetDriveSpeed((cur_speed * speed_gain) / SPEED_GAIN_MID);

	/* ֥졼 */
	Rte_Call_BrakeClt_OpSetBrake(cur_brake);
}

/*
 *  ưΥܥǥϤγǧǽλޤǤΥ
 */
#define START_CNT_MAX	((INIT_BODY_BLINK_CYCLE_MS*INIT_BODY_BLINK_COUNT*2)/BODYCONTROL_RUNNABLE_CYCLE_MS)

/*
 *  BodyControlʥ֥
 */
void
BodyControl(void)
{
	Std_ReturnType	ercd;
	IDT_Lamp		headlamp;
	IDT_Lamp		foglamp;
	IDT_Lamp		hazard;
	IDT_Lamp		winker_r;
	IDT_Lamp		winker_l;
	static uint8	start_cnt = 0U;
	static IDT_Lamp	toggle_headlamp = FALSE;
	static IDT_Lamp	toggle_foglamp = FALSE;
	static IDT_Lamp	toggle_winker_r = FALSE;
	static IDT_Lamp	toggle_winker_l = FALSE;
	static IDT_Lamp	toggle_hazard = FALSE;
	static IDT_Lamp	pre_headlamp = FALSE;
	static IDT_Lamp	pre_foglamp = FALSE;
	static IDT_Lamp	pre_hazard = FALSE;
	static IDT_Lamp	pre_winker_r = FALSE;
	static IDT_Lamp	pre_winker_l = FALSE;

	/* ư */
	if (start_cnt <= START_CNT_MAX) {
		/* WinkerLamp(headfogbrakeback) */
		if ((((start_cnt / (START_CNT_MAX/(INIT_BODY_BLINK_COUNT*2))) % 2U) == 0U)) {
			Rte_Write_LampOut_headlamp(TRUE);
			Rte_Write_LampOut_foglamp(TRUE);
			Rte_Write_LampOut_backlamp(TRUE);
			Rte_Write_LampOut_brakelamp(TRUE);
			Rte_Write_WinkerOut_state(WINKER_LR_ON);
			Rte_Write_BuzzerOut_state(BUZZER_ON);
		}
		else {
			Rte_Write_LampOut_headlamp(FALSE);
			Rte_Write_LampOut_foglamp(FALSE);
			Rte_Write_LampOut_backlamp(FALSE);
			Rte_Write_LampOut_brakelamp(FALSE);
			Rte_Write_WinkerOut_state(WINKER_OFF);
			Rte_Write_BuzzerOut_state(BUZZER_OFF);
		}
		/* ưȥ󥯥 */
		start_cnt++;
	}
	/* ̾ﵯư */
	else {
		/* IfBody */
		ercd = Rte_Read_BodyIn_headlamp(&headlamp);
		ercd += Rte_Read_BodyIn_foglamp(&foglamp);
		ercd += Rte_Read_BodyIn_hazard(&hazard);
		ercd += Rte_Read_BodyIn_winker_r(&winker_r);
		ercd += Rte_Read_BodyIn_winker_l(&winker_l);

		/* 1ĤǤ˼Ԥ³νϼ¹Ԥʤ */
		if (ercd != RTE_E_OK) {
			syslog(LOG_INFO, "## Error: Rte_Read_BodyIn()");
			return;
		}

		/* FALSETRUEܻ˳ƥȥڤؤ */
		if ((pre_headlamp == FALSE) && (headlamp == TRUE)) {
			toggle_headlamp = (toggle_headlamp == FALSE) ? TRUE : FALSE;
		}
		if ((pre_foglamp == FALSE) && (foglamp == TRUE)) {
			toggle_foglamp = (toggle_foglamp == FALSE) ? TRUE : FALSE;
		}
		if ((pre_hazard == FALSE) && (hazard == TRUE)) {
			toggle_hazard = (toggle_hazard == FALSE) ? TRUE : FALSE;
		}
		if ((pre_winker_r == FALSE) && (winker_r == TRUE)) {
			toggle_winker_r = (toggle_winker_r == FALSE) ? TRUE : FALSE;
		}
		if ((pre_winker_l == FALSE) && (winker_l == TRUE)) {
			toggle_winker_l = (toggle_winker_l == FALSE) ? TRUE : FALSE;
		}

		/*
		 *  ׾Ƚ
		 */
		/* إåɥ׾Ƚ */
		if (toggle_headlamp == TRUE) {
			Rte_Write_LampOut_headlamp(TRUE);
		}
		else {
			Rte_Write_LampOut_headlamp(FALSE);
		}

		/* ե׾Ƚ */
		if (toggle_foglamp == TRUE) {
			ercd += Rte_Write_LampOut_foglamp(TRUE);
		}
		else {
			ercd += Rte_Write_LampOut_foglamp(FALSE);
		}

		/* ֥졼׾Ƚ */
		if (cur_brake == TRUE) {
			Rte_Write_LampOut_brakelamp(TRUE);
		}
		else {
			Rte_Write_LampOut_brakelamp(FALSE);
		}

		/* Хå׾Ƚ */
		if (cur_speed < 0) {
			Rte_Write_LampOut_backlamp(TRUE);
		}
		else {
			Rte_Write_LampOut_backlamp(FALSE);
		}

		/*
		 *  󥫡
		 */
		/* 󡤥˥塼ȥĴؼ */
		if ((acklr_cnt != 0U) || (ackr_cnt != 0U) || (ackl_cnt != 0U)) {
			if (acklr_cnt != 0U) {
				acklr_cnt--;
				Rte_Write_WinkerOut_state((acklr_cnt == 0)? WINKER_OFF : WINKER_LR_ON);
			}
			if (ackr_cnt != 0U) {
				ackr_cnt--;
				Rte_Write_WinkerOut_state((ackr_cnt == 0)? WINKER_OFF : WINKER_R_ON);
			}
			if (ackl_cnt != 0U) {
				ackl_cnt--;
				Rte_Write_WinkerOut_state((ackl_cnt == 0)? WINKER_OFF : WINKER_L_ON);
			}
		}
		else {
			/*  */
			if ((toggle_hazard == TRUE) ||
				((toggle_winker_r == TRUE) && (toggle_winker_l == TRUE))) {
				Rte_Write_WinkerOut_state(WINKER_LR_BLINK);
			}
			/* Τ */
			else if (toggle_winker_r == TRUE) {
				Rte_Write_WinkerOut_state(WINKER_R_BLINK);
			}
			/* Τ */
			else if (toggle_winker_l == TRUE) {
				Rte_Write_WinkerOut_state(WINKER_L_BLINK);
			}
			/*  */
			else {
				Rte_Write_WinkerOut_state(WINKER_OFF);
			}
		}

		/*
		 *  Buzzer
		 */
		/* ®ޥʥȽ */
		if (cur_speed < 0) {
			Rte_Write_BuzzerOut_state(BUZZER_INTERVAL_ON);
		}
		else {
			Rte_Write_BuzzerOut_state(BUZZER_OFF);
		}

		/* ¸ */
		pre_headlamp = headlamp;
		pre_foglamp = foglamp;
		pre_hazard = hazard;
		pre_winker_r = winker_r;
		pre_winker_l = winker_l;
	}
}
